﻿using System;
using System.Globalization;
using Pixiview.UI;
using Xamarin.Forms;

namespace Pixiview.Utils
{
    public class PageConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return StyleDefinition.IconLayer + value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class OffsetConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value is Thickness thickness && parameter != null)
            {
                if (double.TryParse(parameter.ToString(), out var offset))
                {
                    return new Thickness(thickness.Left, thickness.Top + offset, thickness.Right, thickness.Bottom);
                }
            }
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
